package com.casic.dcms.ui.fragment.urgent;

import android.content.Context;
import android.content.Intent;
import android.os.Handler;
import android.os.Message;
import android.util.Log;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.DividerItemDecoration;
import androidx.recyclerview.widget.LinearLayoutManager;

import com.casic.dcms.adapter.UrgentCaseAdapter;
import com.casic.dcms.base.AndroidxBaseFragment;
import com.casic.dcms.bean.ActionResultBean;
import com.casic.dcms.bean.UrgentCaseBean;
import com.casic.dcms.databinding.FragmentUrgentCaseBinding;
import com.casic.dcms.mvp.presenter.impl.UrgentCaseListPresenterImpl;
import com.casic.dcms.mvp.view.IUrgentCaseListView;
import com.casic.dcms.ui.CaseTodoHandledDetailActivity;
import com.casic.dcms.utils.Constant;
import com.casic.dcms.utils.ToastHelper;
import com.scwang.smartrefresh.layout.api.RefreshLayout;
import com.scwang.smartrefresh.layout.listener.OnLoadMoreListener;
import com.scwang.smartrefresh.layout.listener.OnRefreshListener;

import java.lang.ref.WeakReference;
import java.util.ArrayList;
import java.util.List;

public class CaseHandledFragment extends AndroidxBaseFragment<FragmentUrgentCaseBinding> implements IUrgentCaseListView {

    private static final String TAG = "CaseHandledFragment";
    private Context context;
    private int pageIndex = 1;
    private UrgentCaseListPresenterImpl urgentCaseListPresenter;
    private List<UrgentCaseBean.DataBean.RowsBean> dataBeans = new ArrayList<>();
    private boolean isRefresh, isLoadMore = false;
    private UrgentCaseAdapter adapter;
    private static WeakReferenceHandler weakReferenceHandler;

    @Override
    protected void setupTopBarLayout() {
        context = getContext();
    }

    @Override
    protected void initData() {
        urgentCaseListPresenter = new UrgentCaseListPresenterImpl(this);
        //isSupervise	否	string	是否督办,0-未督办，1-已督办
        urgentCaseListPresenter.onReadyRetrofitRequest("1", pageIndex);

        weakReferenceHandler = new WeakReferenceHandler(this);
    }

    @Override
    protected void initEvent() {
        viewBinding.refreshLayout.setOnRefreshListener(new OnRefreshListener() {
            @Override
            public void onRefresh(@NonNull final RefreshLayout refreshLayout) {
                isRefresh = true;
                pageIndex = 1;
                urgentCaseListPresenter.onReadyRetrofitRequest("1", pageIndex);
            }
        });
        viewBinding.refreshLayout.setOnLoadMoreListener(new OnLoadMoreListener() {
            @Override
            public void onLoadMore(@NonNull final RefreshLayout refreshLayout) {
                isLoadMore = true;
                pageIndex++;
                urgentCaseListPresenter.onReadyRetrofitRequest("1", pageIndex);
            }
        });
    }

    /**
     * 供{@link com.casic.dcms.ui.CaseTodoDetailActivity#obtainUpdateData(ActionResultBean)}调用
     */
    public static void sendEmptyMessage(int what) {
        if (weakReferenceHandler == null) {
            return;
        }
        weakReferenceHandler.sendEmptyMessage(what);
    }

    private static class WeakReferenceHandler extends Handler {
        private final WeakReference<CaseHandledFragment> reference;

        private WeakReferenceHandler(CaseHandledFragment fragment) {
            reference = new WeakReference<>(fragment);
        }

        @Override
        public void handleMessage(Message msg) {
            CaseHandledFragment handledFragment = reference.get();
            if (msg.what == Constant.CASE_URGENT_OK) {
                Log.d(TAG, "紧急督办成功，更新列表");
                handledFragment.isRefresh = true;
                //刷新之后页码重置
                handledFragment.pageIndex = 1;
                handledFragment.urgentCaseListPresenter.onReadyRetrofitRequest("1", handledFragment.pageIndex);
            } else if (msg.what == 202104282) {
                if (handledFragment.isRefresh || handledFragment.isLoadMore) {
                    handledFragment.adapter.notifyDataSetChanged();
                } else {
                    //首次加载数据
                    if (handledFragment.dataBeans.size() == 0) {
                        handledFragment.viewBinding.emptyView.show("没有紧急案卷", null);
                    } else {
                        handledFragment.viewBinding.emptyView.hide();
                        handledFragment.adapter = new UrgentCaseAdapter(handledFragment.context, handledFragment.dataBeans);
                        handledFragment.viewBinding.caseRecyclerView.setLayoutManager(new LinearLayoutManager(handledFragment.context));
                        handledFragment.viewBinding.caseRecyclerView.addItemDecoration(new DividerItemDecoration(handledFragment.context, DividerItemDecoration.VERTICAL));
                        handledFragment.viewBinding.caseRecyclerView.setAdapter(handledFragment.adapter);
                        handledFragment.adapter.setOnItemClickListener(new UrgentCaseAdapter.OnItemClickListener() {
                            @Override
                            public void onClick(int position) {
                                Intent intent = new Intent(handledFragment.context, CaseTodoHandledDetailActivity.class);
                                intent.putExtra("id", handledFragment.dataBeans.get(position).getId());
                                handledFragment.startActivity(intent);
                            }
                        });
                    }
                }
            }
        }
    }

    @Override
    public void obtainUrgentCaseList(UrgentCaseBean resultBean) {
//        Log.d(TAG, "obtainUrgentCaseList: " + new Gson().toJson(resultBean));
        if (resultBean.isSuccess()) {
            List<UrgentCaseBean.DataBean.RowsBean> dataRows = resultBean.getData().getRows();
            if (isRefresh) {
                dataBeans.clear();//下拉刷新必须先清空之前的List，不然会出现数据重复的问题
                dataBeans = dataRows;
                viewBinding.refreshLayout.finishRefresh();
                isRefresh = false;
            } else if (isLoadMore) {
                if (dataRows.size() == 0) {
                    ToastHelper.showToast("到底了，别拉了", ToastHelper.INFO);
                }
                dataBeans.addAll(dataRows);
                viewBinding.refreshLayout.finishLoadMore();
                isLoadMore = false;
            } else {
                dataBeans = dataRows;
            }
            weakReferenceHandler.sendEmptyMessage(202104282);
        }
    }

    @Override
    public void onDestroyView() {
        if (urgentCaseListPresenter != null) {
            urgentCaseListPresenter.disposeRetrofitRequest();
        }
        super.onDestroyView();
    }
}
